## sra-sdk 3.0.9+dfsg

=== test/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

# this is where test executables will be created
# to access tools themselves, use ${BINDIR}
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${TESTBINDIR} )
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG ${TESTBINDIR_DEBUG} )
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE ${TESTBINDIR_RELEASE} )

if ( NOT SINGLE_CONFIG )
	set( COMMON_LINK_LIBRARIES ${COMMON_LINK_LIBRARIES} ktst )
else()
	set( COMMON_LINK_LIBRARIES ${COMMON_LINK_LIBRARIES} ${NCBI_VDB_LIBDIR}/libktst.${STLX} )
endif()

add_subdirectory( vdb )
add_subdirectory( external )
if( BUILD_TOOLS_LOADERS )
	add_subdirectory( loaders )
endif()
if( BUILD_TOOLS_INTERNAL )
	add_subdirectory( internal )
endif()
if( BUILD_TOOLS_TEST_TOOLS )
	add_subdirectory( test-tools )
endif()

#add_subdirectory( ngs ) # moved to test/external
#add_subdirectory( align ) # moved to test/internal
#add_subdirectory( test_sanitizers ) # move to test/internal

add_subdirectory( scripts ) # move to test/internal

# add_subdirectory(samline) # command line tool; move to tools/internal

# add_subdirectory(tarballs) # called directly from TeamCity

=== tools/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BINDIR} )

add_subdirectory( external )
if( BUILD_TOOLS_LOADERS )
	add_subdirectory( loaders )
endif()
if( BUILD_TOOLS_INTERNAL )
	add_subdirectory( internal )
endif()
if( BUILD_TOOLS_TEST_TOOLS )
	add_subdirectory( test-tools )
endif()

=== build/docker/Makefile ===
# Make file for building SRA Toolkit docker image

ifndef VERSION
$(error VERSION needs to be set, e.g. make VERSION=2.11.1 build)
endif

DOCKER_ARCH := $(shell docker info | perl -ne'print "$$1\n" if /Architecture:\s*(\w+)/')
BRANCH?=${VERSION}rc
REPO=ncbi/sra-tools
TAG=${DOCKER_ARCH}-${VERSION}

.DEFAULT: build
.PHONY: build push manifest clean test help

help:
	@ echo "targets are: build, test, push, manifest, and clean"

build:
	docker pull alpine:latest
	docker build --build-arg VDB_BRANCH=${BRANCH} --tag ${REPO}:${TAG} -f Dockerfile.build-alpine .

test:
	docker run -it --rm ${REPO}:${TAG} fastq-dump -X 5 -Z SRR000001

push:
	docker push ${REPO}:${TAG}
	@ echo Remember to make VERSION=${VERSION} manifest once all the images are built.

manifest:
	# Need to remove any old manifests with the same tags we are creating
	docker manifest rm ${REPO}:latest || true
	docker manifest rm ${REPO}:${VERSION} || true
	docker manifest create ${REPO}:${VERSION} $(shell perl find-parts.pl ${VERSION})
	docker manifest push ${REPO}:${VERSION}
	docker manifest create ${REPO}:latest ${REPO}:x86_64-${VERSION} ${REPO}:aarch64-${VERSION}
	docker manifest push ${REPO}:latest

clean:
	docker image rm ${REPO}:${TAG}
	docker manifest rm ${REPO}:latest
	docker manifest rm ${REPO}:${VERSION}

=== libs/ascp/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set ( UNIX_SRC unix/connect.c )
set ( LINUX_SRC ${UNIX_SRC} linux/ascp-path.c )
set ( MAC_SRC ${UNIX_SRC} mac/ascp-path.c )
set ( WIN_SRC win/connect.c win/ascp-path.c )

if ( "windows" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${WIN_SRC} )
elseif( "linux" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${LINUX_SRC} )
elseif( "mac" STREQUAL ${OS} )
    set ( OS_SPECIFIC_SRC ${MAC_SRC} )
endif()

set( SRC
    ascp.c
    ${OS_SPECIFIC_SRC}
)

if ( "GNU" STREQUAL "${CMAKE_C_COMPILER_ID}")
    SET_SOURCE_FILES_PROPERTIES(${UNIX_SRC} PROPERTIES COMPILE_FLAGS -Wno-unused-result)
endif()

GenerateStaticLibs(ascp
    "${SRC}"
)

add_compile_definitions( __mod__="libs/ascp" )
include_directories( BEFORE ${CMAKE_CURRENT_SOURCE_DIR} )

=== libs/diagnose/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

set( SRC
    diagnose.c
    endpoint.c
)

GenerateStaticLibs(diagnose
    "${SRC}"
)

add_compile_definitions( __mod__="libs/ascp" )
include_directories( BEFORE ${CMAKE_CURRENT_SOURCE_DIR} )

=== ngs/ngs-java/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

if ( Java_FOUND )

    include(UseJava)

    ########################################
    # ngs-java.jar

    # java API
    set( NGS_SRC
        ngs/ErrorMsg.java
        ngs/Statistics.java
        ngs/Fragment.java
        ngs/FragmentIterator.java
        ngs/Read.java
        ngs/ReadIterator.java
        ngs/ReadGroup.java
        ngs/ReadGroupIterator.java
        ngs/Alignment.java
        ngs/AlignmentIterator.java
        ngs/PileupEvent.java
        ngs/PileupEventIterator.java
        ngs/Pileup.java
        ngs/PileupIterator.java
        ngs/Reference.java
        ngs/ReferenceIterator.java
        ngs/ReadCollection.java
        ngs/Package.java
    )

    # java language bindings
    set( ITF_SRC
        ngs/itf/Refcount.java
        ngs/itf/StatisticsItf.java
        ngs/itf/FragmentItf.java
        ngs/itf/FragmentIteratorItf.java
        ngs/itf/ReadItf.java
        ngs/itf/ReadIteratorItf.java
        ngs/itf/ReadGroupItf.java
        ngs/itf/ReadGroupIteratorItf.java
        ngs/itf/AlignmentItf.java
        ngs/itf/AlignmentIteratorItf.java
        ngs/itf/PileupEventItf.java
        ngs/itf/PileupEventIteratorItf.java
        ngs/itf/PileupItf.java
        ngs/itf/PileupIteratorItf.java
        ngs/itf/ReferenceItf.java
        ngs/itf/ReferenceIteratorItf.java
        ngs/itf/ReadCollectionItf.java
    )

    # NCBI engine bindings
    set( NCBI_SRC
        gov/nih/nlm/ncbi/ngs/DownloadManager.java
        gov/nih/nlm/ncbi/ngs/FileCreator.java
        gov/nih/nlm/ncbi/ngs/HttpManager.java
        gov/nih/nlm/ncbi/ngs/LibDependencies.java
        gov/nih/nlm/ncbi/ngs/LibManager.java
        gov/nih/nlm/ncbi/ngs/LibPathIterator.java
        gov/nih/nlm/ncbi/ngs/LibVersionChecker.java
        gov/nih/nlm/ncbi/ngs/LMProperties.java
        gov/nih/nlm/ncbi/ngs/Logger.java
        gov/nih/nlm/ncbi/ngs/Manager.java
        gov/nih/nlm/ncbi/ngs/NGS.java
        gov/nih/nlm/ncbi/ngs/Version.java
        gov/nih/nlm/ncbi/ngs/error/LibraryLoadError.java
        gov/nih/nlm/ncbi/ngs/error/LibraryNotFoundError.java
        gov/nih/nlm/ncbi/ngs/error/LibraryIncompatibleVersionError.java
        gov/nih/nlm/ncbi/ngs/error/cause/ConnectionProblemCause.java
        gov/nih/nlm/ncbi/ngs/error/cause/DownloadDisabledCause.java
        gov/nih/nlm/ncbi/ngs/error/cause/InvalidLibraryCause.java
        gov/nih/nlm/ncbi/ngs/error/cause/JvmErrorCause.java
        gov/nih/nlm/ncbi/ngs/error/cause/LibraryLoadCause.java
        gov/nih/nlm/ncbi/ngs/error/cause/OutdatedJarCause.java
        gov/nih/nlm/ncbi/ngs/error/cause/PrereleaseReqLibCause.java
        gov/nih/nlm/ncbi/ngs/error/cause/UnsupportedArchCause.java
    )

    find_package(JNI)

    if ( JNI_FOUND )
        add_jar( ngs-java
            SOURCES ${NGS_SRC} ${ITF_SRC} ${NCBI_SRC}
            OUTPUT_DIR ${CMAKE_JAR_OUTPUT_DIRECTORY}
            GENERATE_NATIVE_HEADERS ngs-jni-headers DESTINATION ./jni
        )
    else()
        add_jar( ngs-java
            SOURCES ${NGS_SRC} ${ITF_SRC} ${NCBI_SRC}
            OUTPUT_DIR ${CMAKE_JAR_OUTPUT_DIRECTORY}
        )
    endif()

    install_jar( ngs-java ${CMAKE_INSTALL_PREFIX}/jar/ )
    #TODO: add symlinks

    ########################################
    # examples
    add_subdirectory( examples )
    ########################################
    # javadoc
    if ( Java_JAVADOC_EXECUTABLE )
        create_javadoc( ngs-doc
            PACKAGES gov.nih.nlm.ncbi.ngs ngs
            SOURCEPATH ${CMAKE_CURRENT_SOURCE_DIR}
        )

        foreach(f ${NGS_SRC})
            set(SRC_FILES "${SRC_FILES} ${f}")
        endforeach()

        foreach(f ${ITF_SRC})
            set(SRC_FILES "${SRC_FILES} ${f}")
        endforeach()

        foreach(f ${NCBI_SRC})
            set(SRC_FILES "${SRC_FILES} ${f}")
        endforeach()

        set( NGS_JAVADOC_DIR ${CMAKE_BINARY_DIR}/ngs/ngs-java/javadoc/ngs-doc )
        if ( Java_JAR_EXECUTABLE AND NOT (${OS} STREQUAL "windows") )
            add_custom_target(
                ngs-doc-jar ALL COMMAND
                bash -c "${Java_JAR_EXECUTABLE} -cf ${CMAKE_JAR_OUTPUT_DIRECTORY}/ngs-doc.jar ."
                DEPENDS ngs-doc_javadoc
                WORKING_DIRECTORY ${NGS_JAVADOC_DIR}
            )
            install( FILES ${CMAKE_JAR_OUTPUT_DIRECTORY}/ngs-doc.jar DESTINATION ${CMAKE_INSTALL_PREFIX}/jar/ )

            add_custom_target(
                ngs-src-jar ALL COMMAND
                bash -c "${Java_JAR_EXECUTABLE} -cf ${CMAKE_JAR_OUTPUT_DIRECTORY}/ngs-src.jar ${SRC_FILES}"
                DEPENDS ngs-doc_javadoc
                WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
            )
            install( FILES ${CMAKE_JAR_OUTPUT_DIRECTORY}/ngs-src.jar DESTINATION ${CMAKE_INSTALL_PREFIX}/jar/ )
        elseif ( Java_JAR_EXECUTABLE AND ${OS} STREQUAL "windows" )
            add_custom_target(
                ngs-doc-jar ALL COMMAND
                "${Java_JAR_EXECUTABLE}" -cf "${CMAKE_JAR_OUTPUT_DIRECTORY}/ngs-doc.jar" .
                DEPENDS ngs-doc_javadoc
                WORKING_DIRECTORY ${NGS_JAVADOC_DIR}
            )
            install( FILES ${CMAKE_JAR_OUTPUT_DIRECTORY}/ngs-doc.jar DESTINATION ${CMAKE_INSTALL_PREFIX}/jar/ )

            # https://jira.ncbi.nlm.nih.gov/browse/VDB-4761 - temporarily disabling
            # add_custom_target(
                # ngs-src-jar ALL COMMAND
                # "${Java_JAR_EXECUTABLE}" -cf "${CMAKE_JAR_OUTPUT_DIRECTORY}/ngs-src.jar" ${SRC_FILES}
                # WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
            # )
            # install( FILES ${CMAKE_JAR_OUTPUT_DIRECTORY}/ngs-src.jar DESTINATION ${CMAKE_INSTALL_PREFIX}/jar/ )
        endif()
    endif()
endif()

=== ngs/ngs-java/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

TOP ?= $(abspath ../..)
MODULE = ngs/ngs-java

include $(TOP)/build/Makefile.env

=== test/loaders/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)
MODULE = test/loaders

BUILD_TOOLS_LOADERS = ON
include $(TOP)/build/Makefile.env

=== test/samline/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

if( NOT WIN32 )

    # specify the location of schema files in a local .kfg file, to be used by the tests here as needed
    #add_test(NAME LatfTestSetup COMMAND bash -c "echo 'vdb/schema/paths = \"${VDB_INCDIR}\"\n/LIBS/GUID=\"8test002-6ab7-41b2-bfd0-latfload\"' > tmp.kfg" WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )

    # build the 2 helper-tools used in scripted tests:
    add_executable( samline refbases.c cigar.c alig-gen.c )
    add_executable( sampart refbases.c cigar.c sampart.c )

    # link agains libs 
    target_link_libraries( samline ${COMMON_LINK_LIBRARIES} ${COMMON_LIBS_READ} )
    target_link_libraries( sampart ${COMMON_LINK_LIBRARIES} ${COMMON_LIBS_READ} )

    #add_test( NAME Test_Samline
    #        COMMAND
    #            ${CMAKE_COMMAND} -E env NCBI_SETTINGS=/
    #            ${CMAKE_COMMAND} -E env VDB_CONFIG=${CMAKE_CURRENT_SOURCE_DIR}
    #            "./simple_test.sh" "${BINDIR}" "${TESTBINDIR}"
    #        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    #    )

    #add_test( NAME Test_Samline
    #        COMMAND "./simple_test.sh" "${BINDIR}" "${TESTBINDIR}"
    #        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    #    )

    add_test( NAME Test_SamBuild
            COMMAND "./1.sh" "${BINDIR}" "${TESTBINDIR}"
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )
    
endif()

=== test/test-tools/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

default: runtests

TOP ?= $(abspath ../..)
MODULE = test/test-tools

include $(TOP)/build/Makefile.env

=== test/vdb/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

AddExecutableTest( test-vdb "test-vdb" "kapp;${COMMON_LINK_LIBRARIES};${COMMON_LIBS_READ}" "" )

=== tools/internal/CMakeLists.txt ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================

add_subdirectory( align-cache )
add_subdirectory( ccextract )
add_subdirectory( copycat )
add_subdirectory( make-read-filter )
add_subdirectory( md5cp )
add_subdirectory( meta-cmp )
add_subdirectory( meta-copy )
add_subdirectory( meta-repair )
add_subdirectory( rd-filter-redact )
add_subdirectory( vdb-copy )
add_subdirectory( vdb-diff )
add_subdirectory( vdb-sql )
add_subdirectory( check-redact )

=== debian/changelog ===
sra-sdk (3.0.9+dfsg-7.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-Depend on python3-setuptools, used in the test suite.
    (Closes: #1099911)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 09 Mar 2025 10:33:36 -0400

sra-sdk (3.0.9+dfsg-7) unstable; urgency=medium

  * Upload to unstable to join Mbed TLS 3.x.  (See #1075868.)
  * debian/salsa-ci.yml: Comment out aptly setup, no longer needed.
  * Add changelog entries for 3.0.3+dfsg-7 through -9 to placate dgit.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 17 Oct 2024 22:48:06 -0400

sra-sdk (3.0.9+dfsg-6) experimental; urgency=medium

  * Team upload
  * Adding missing #include <algorithm> to use std::transform

 -- Pierre Gruet <pgt@debian.org>  Tue, 20 Aug 2024 22:46:44 +0200

sra-sdk (3.0.9+dfsg-5) experimental; urgency=medium

  * Team upload
  * Building against HDF5/1.14.4.3

 -- Pierre Gruet <pgt@debian.org>  Tue, 20 Aug 2024 09:45:01 +0200

sra-sdk (3.0.9+dfsg-4) experimental; urgency=medium

  * Team upload
  * Removing unneeded markdown and discount from B-D

 -- Pierre Gruet <pgt@debian.org>  Fri, 12 Jul 2024 07:48:57 +0200

sra-sdk (3.0.9+dfsg-3) experimental; urgency=medium

  * debian/control: Build depend on libabsl-dev so binaries using libre2
    (sharq and relevant tests) can unconditionally link against
    -labsl_string_view for simplicitly.
  * debian/patches/support_libre2-11.patch (new): Prepare for (but don't
    require!) newer libre2 versions where re2::StringPiece has changed
    from a custom class to a typedef for absl::string_view, whose API is
    somewhat different.  (Closes: #1053411.)

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 05 May 2024 22:45:27 -0400

sra-sdk (3.0.9+dfsg-2) experimental; urgency=medium

  * debian/patches/fix_arm64_build.patch (new): Fix arm64 builds by
    tweaking BitMagic to treat __aarch64__ like __arm64__.

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 12 Apr 2024 19:32:51 -0400

sra-sdk (3.0.9+dfsg-1) experimental; urgency=medium

  [ Andreas Tille ]
  * New upstream version

  [ Aaron M. Ucko ]
  * debian/control:
    - Tighten libncbi-vdb-dev requirement to (>= 3.0.9+dfsg~) per
      upstream expectations; this stack has to stay in experimental as
      long as mbed TLS 3 does, calling for explicit hints.
    - Drop explicit B-D on python3-distutils, currently redundant with
      dh-python (which depends on it via python3-setuptools) and found
      unnecessary regardless in Ubuntu.  (Closes: #1065961.)
  * debian/patches/label_online_tests.patch:
    - Correctly place test/internal/vdb-diff/CMakeLists.txt's change; its
      set_tests_properties call accidentally wound up ahead of the
      corresponding add_test calls.
    - Label 55 additional tests as needing network access.
  * debian/salsa-ci.yml: Try to ensure availability of experimental VDB,
    both by setting RELEASE to experimental and by reinstating aptly, now
    using job 5576517.
  * debian/sra-toolkit.links: Drop; its only entry has dangled since
    vdb-get retired (in upstream version 3.0.1).  (Closes: #1040391.)
  * Standards-Version: 4.7.0 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 12 Apr 2024 18:02:49 -0400

sra-sdk (3.0.3+dfsg-9) unstable; urgency=medium

  * Team upload
  * Building against HDF5/1.14.4.3 (Closes: #1078882)

 -- Pierre Gruet <pgt@debian.org>  Tue, 20 Aug 2024 09:40:26 +0200

sra-sdk (3.0.3+dfsg-8) unstable; urgency=medium

  * Team upload.
  * Removing B-D on markdown or discount for building the doc
  * Building with python3-setuptools instead of removed python3-distutils

 -- Pierre Gruet <pgt@debian.org>  Thu, 11 Jul 2024 14:39:57 +0200

sra-sdk (3.0.3+dfsg-7) unstable; urgency=medium

  * debian/control: Build depend on libabsl-dev so binaries using libre2
    (sharq and relevant tests) can unconditionally link against
    -labsl_string_view for simplicitly.
  * debian/patches/support_libre2-11.patch (new): Prepare for (but don't
    require!) newer libre2 versions where re2::StringPiece has changed
    from a custom class to a typedef for absl::string_view, whose API is
    somewhat different.  (Closes: #1053411.)

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 05 May 2024 22:15:17 -0400

=== debian/control ===
Source: sra-sdk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>,
           Aaron M. Ucko <ucko@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               d-shlibs,
               dh-python,
               javahelper,
               libabsl-dev,
               libncbi-vdb-dev (>= 3.0.9+dfsg~),
               libfuse-dev,
               libhdf5-dev,
               libmagic-dev,
               libre2-dev,
               libxml2-dev,
               libzstd-dev,
               liblzma-dev,
               libsam-extract-dev,
               maven-repo-helper,
               python3-all,
               python3-setuptools,
               default-jdk,
               flex,
               bison
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/med-team/sra-sdk
Vcs-Git: https://salsa.debian.org/med-team/sra-sdk.git
Homepage: https://github.com/ncbi/sra-tools/
Rules-Requires-Root: no

Package: sra-toolkit
Architecture: amd64 arm64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: med-config
Description: utilities for the NCBI Sequence Read Archive
 Tools for reading the SRA archive, generally by converting individual runs
 into some commonly used format such as fastq.
 .
 The textual dumpers "sra-dump" and "vdb-dump" are provided in this
 release as an aid in visual inspection. It is likely that their
 actual output formatting will be changed in the near future to a
 stricter, more formalized representation[s]. PLEASE DO NOT RELY UPON
 THE OUTPUT FORMAT SEEN IN THIS RELEASE.
 .
 Other tools distributed in this package are:
  abi-dump, abi-load
  align-info
  bam-load
  cache-mgr
  cg-load
  copycat
  fasterq-dump
  fastq-dump, fastq-load
  helicos-load
  illumina-dump, illumina-load
  kar
  kdbmeta
  latf-load
  pacbio-load
  prefetch
  rcexplain
  remote-fuser
  sff-dump, sff-load
  sra-pileup, sra-sort, sra-stat, srapath
  srf-load
  test-sra
  vdb-config, vdb-copy, vdb-decrypt, vdb-encrypt, vdb-get, vdb-lock,
  vdb-passwd, vdb-unlock, vdb-validate
 .
 The "help" information will be improved in near future releases, and
 the tool options will become standardized across the set. More documentation
 will also be provided documentation on the NCBI web site.
 .
 Tool options may change in the next release. Version 1 tool options
 will remain supported wherever possible in order to preserve
 operation of any existing scripts.

Package: libngs-c++3
Multi-Arch: same
Architecture: amd64 arm64
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings (C++ runtime)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libngs-c++-dev
Multi-Arch: same
Architecture: amd64 arm64
Section: libdevel
Depends: ${misc:Depends},
         libngs-c++3 (= ${binary:Version})
Breaks: libncbi-vdb-dev (<< 3), libngs-sdk-dev (<< 3)
Replaces: libncbi-vdb-dev (<< 3), libngs-sdk-dev (<< 3)
Description: Next Generation Sequencing language Bindings (C++ development)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 This is the development package for C++ usage.

Package: libncbi-ngs3
Multi-Arch: same
Architecture: amd64 arm64
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings (full runtime)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.

Package: libncbi-ngs-dev
Multi-Arch: same
Architecture: amd64 arm64
Section: libdevel
Depends: ${misc:Depends},
         libncbi-ngs3 (= ${binary:Version}),
         libngs-c++-dev (= ${binary:Version})
Description: Next Generation Sequencing language Bindings (C++ development)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 This is the full development package.

Package: libngs-java
Multi-Arch: same
Architecture: amd64 arm64
Section: java
Depends: ${java:Depends},
         ${misc:Depends},
         libngs-jni (>= ${source:Version}),
         libngs-jni (<< ${source:Version}.1~)
Recommends: ${java:Recommends}
Suggests: libngs-java-doc
Description: Next Generation Sequencing language Bindings (Java bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Java bindings.

Package: libngs-jni
Multi-Arch: same
Architecture: amd64 arm64
Section: java
Depends: ${shlibs:Depends},
         libncbi-ngs3 (= ${binary:Version}),
         ${misc:Depends}
Description: Next Generation Sequencing language Bindings (Java native binding)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Java native bindings.

Package: libngs-java-doc
Multi-Arch: foreign
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Next Generation Sequencing language Bindings (Java documentation)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Documentation for the Java bindings.

Package: python3-ngs
Architecture: all
Section: python
Depends: ${python3:Depends},
         ${misc:Depends},
         libncbi-ngs3 (>= ${source:Version}),
         libncbi-ngs3 (<< ${source:Version}.1~)
Description: Next Generation Sequencing language Bindings (Python3 bindings)
 NGS is a new, domain-specific API for accessing reads, alignments and
 pileups produced from Next Generation Sequencing. The API itself is
 independent from any particular back-end implementation, and supports
 use of multiple back-ends simultaneously. It also provides a library for
 building new back-end "engines". The engine for accessing SRA data is
 contained within the sister repository ncbi-vdb.
 .
 The API is currently expressed in C++, Java and Python languages. The
 design makes it possible to maintain a high degree of similarity between
 the code in one language and code in another - especially between C++
 and Java.
 .
 Python3 bindings.

=== debian/rules ===
#!/usr/bin/make -f

# Pregenerated with uuidgen -r
DEBIAN_GUID = 806b5c3b-0088-4732-8359-51630950d723

# +pie breaks the build
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Building against hdf5/1.14.4.3, forwarded: https://github.com/ncbi/sra-tools/issues/958
export DEB_CPPFLAGS_MAINT_APPEND = -DH5_USE_110_API

export DEB_CFLAGS_MAINT_APPEND   = -fsigned-char
export DEB_CXXFLAGS_MAINT_APPEND = -fsigned-char

pkg := sra-toolkit

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

build3vers := $(shell py3versions -sv)

%:
	dh $@ --buildsystem=cmake \
	    --with python3,javahelper,jh_maven_repo_helper

OUTDIR=$(CURDIR)/debian/tmp

override_dh_auto_clean:
	dh_auto_clean
	rm -rf ngs/ngs-java/$(DEB_HOST_MULTIARCH)
	rm -rf ngs/ngs-bam/$(DEB_HOST_MULTIARCH)
	rm -f ngs/ngs-bam/Makefile.config
	rm -f ngs/ngs-bam/Makefile.config.install.linux.x86_64.prl
	rm -f ngs/ngs-bam/Makefile.config.linux.x86_64
	rm -f ngs/ngs-bam/reconfigure
	rm -rf ngs/ngs-sdk/ngs/unix/generic

	rm -rf ngs/ngs-sdk/$(DEB_HOST_MULTIARCH)
	rm -rf ngs/ngs-python/build ngs/ngs-python/dist
	rm -rf ngs/ngs-python/ngs.egg-info

	find test tools -name actual -type d | xargs -rt rm -rf
	rm -rf ngs/ngs-*/examples/actual/*
	rm -fv test/*/*/tmp.kfg
	rm -rf libs/ngs-vdb/test/data/SparseFragmentBlobs
	rm -rf test/external/vdb-dump/data test/loaders/bam-load/out.sra
	find tools/loaders/general-loader/test -name input | xargs -rt rm -rf
	rm -f ngs/ngs-sdk/examples/actual.txt

	-rm debian/libngs-jni.links

override_dh_auto_configure:
	dh_auto_configure -- -DVDB_LIBDIR=/usr/lib/${DEB_HOST_MULTIARCH} \
	    -DVDB_INCDIR=/usr/include/ncbi-vdb -DBUILD_TOOLS_LOADERS=ON \
	    -DBUILD_TOOLS_INTERNAL=ON -DBUILD_TOOLS_TEST_TOOLS=ON \
	    -DCMAKE_SKIP_RPATH=ON -DTOOLS_ONLY=OFF \
	    -DCOMPILER_OPTION_SSE42_SUPPORTED=FALSE

KFG_INC  = /usr/include/ncbi-vdb/kfg/ncbi
KFG_DEST = debian/sra-toolkit/etc/ncbi
override_dh_auto_install:
	dh_auto_install
	# build/install.sh $(KFG_INC) \
	# 		 $(CURDIR)/tools/internal/vdb-copy \
	# 		 $(KFG_DEST) \
	# 		 $(KFG_DEST) \
	# 		 debian/sra-toolkit/usr/bin \
	# 		 debian/sra-toolkit/usr/lib/$(DEB_HOST_MULTIARCH) \
	# 		 $(CURDIR)/shared/kfgsums
	build/install-kfg.sh default.kfg $(KFG_INC) $(KFG_DEST) \
			     $(KFG_INC)/kfgsums
	build/install-kfg.sh certs.kfg $(KFG_INC) $(KFG_DEST) \
			     $(KFG_INC)/kfgsums
	build/install-kfg.sh vdb-copy.kfg $(CURDIR)/tools/internal/vdb-copy \
			     $(KFG_DEST) $(CURDIR)/shared/kfgsums
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-a \
		    --exclude-la \
		    --movedev "debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/libncbi-ngs.a*" \
			usr/lib/$(DEB_HOST_MULTIARCH) \
		    --override "s/libncbi-vdb3-dev/libncbi-vdb-dev/" \
		    debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/libncbi-ngs.so
# Ignore spurious failures from pluses; --ignorelibdep only partially helps.
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-a \
		    --exclude-la \
		    --movedev "debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/lib*c++.a*" \
			usr/lib/$(DEB_HOST_MULTIARCH) \
		    --movedev "debian/tmp/usr/include/*" usr/include \
		    --ignorelibdep \
		    debian/*/usr/lib/$(DEB_HOST_MULTIARCH)/libngs-c++.so | \
		tee /dev/stderr | LC_ALL=C grep '^[a-z]' | sh

override_dh_install:
	# upstream installs versioned *.a libs - we only want a single version
	for d in debian/lib*-dev/usr/lib/$(DEB_HOST_MULTIARCH) ; do \
	    for slib in $$d/lib*.a ; do \
		mv $$d/`readlink $$slib` $$slib ; \
		mv $$d/`readlink $$slib` $$slib ; \
	    done ; \
	done
	ls -l debian/tmp/usr/bin
	cd debian/tmp/usr/bin && \
	for bin in *-orig.* ; do \
	    base=$${bin%-orig.*} && \
	    vbase=$$(readlink "$$(readlink $$base)") && \
	    vdriver=$$(readlink "$$vbase") && \
	    mv -v $$bin $$base-orig && \
	    ln -snfv $${vdriver%%.[0-9]*} $$vbase || exit $$? ; \
	done && \
	for bin in *[a-z+] ; do \
	    bin2=$$(readlink $$bin) ; \
	    bin3=$$(readlink "$$bin2") ; \
	    case $$bin2 in \
	        $$bin.* ) rm -v $$bin2 && mv -v $$bin3 $$bin || exit $$? ;; \
	    esac ; \
	done
	mkdir debian/tmp/usr/lib/sra-toolkit
	mv debian/tmp/usr/bin/sratools debian/tmp/usr/lib/sra-toolkit
	for x in debian/tmp/usr/bin/*-orig; do \
	    mv -v $$x debian/tmp/usr/lib/sra-toolkit ; \
	    ln -snfv ../lib/sra-toolkit/sratools $${x%-orig} ; \
	done
	dh_install
	# remove susipcious file which is not executable and conflicts with package magic
	rm -f debian/*/usr/bin/magic
	# Formally supply a standard installation ID to satisfy sratools
	echo '/LIBS/GUID = "$(DEBIAN_GUID)"' >debian/$(pkg)/etc/ncbi/debian.kfg
	set -e && for i in $(build3vers); do \
	    cd ngs/ngs-python; \
	    python$$i ./setup.py install --install-layout=deb \
	        --root $(CURDIR)/debian/python3-ngs; \
	    cd ../..; \
	done
	find debian -name "*.pyc" -delete
	find debian -type d -name __pycache__ | xargs rm -rf

override_dh_installexamples:
	dh_installexamples
	find debian/*/ -name .gitignore -delete

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd obj-$(DEB_HOST_MULTIARCH)  && \
	    ctest --force-new-ctest-process --verbose -j1 -LE online
endif

override_dh_prep:
	dh_prep -X debian/tmp

execute_before_dh_link:
	# Putting the upstream version number (without the dfsg part) at the end of
	# symlink source in the -jni package.
	sed -e 's/\(#STRIPPED_UPSTREAM_VERSION#\)/\1$(DEB_VERSION_UPSTREAM)/' \
	    -e 's/#STRIPPED_UPSTREAM_VERSION#\(.*\)+dfsg[0-9]*/\1/' \
	    -e 's/\$$[({]DEB_HOST_MULTIARCH[)}]/$(DEB_HOST_MULTIARCH)/g' \
	    debian/libngs-jni.links.in > debian/libngs-jni.links

# require network, not automatically run
# use it when the pom file must be re-downloaded from maven repo
BASE_URL:=https://repo.maven.apache.org/maven2/gov/nih/nlm/ncbi/ngs-java
WGET=wget --no-clobber
get-poms:
	$(RM) debian/ngs-java.pom debian/ngs-java.pom.asc
	# extract upstream version
	$(WGET) -O debian/ngs-java.pom $(BASE_URL)/$(DEB_VERSION_UPSTREAM)/ngs-java-$(DEB_VERSION_UPSTREAM).pom && \
	$(WGET) -O debian/ngs-java.pom.asc $(BASE_URL)/$(DEB_VERSION_UPSTREAM)/ngs-java-$(DEB_VERSION_UPSTREAM).pom.asc
	gpg --trust-model=always --status-fd 1 --no-default-keyring --keyring debian/sra-tools.gpg --verify debian/ngs-java.pom.asc
